﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Wariancja
{
    using static Console;

    class Program
    {
        #region Inwariantny
        interface ITypInwariantny<Typ>
        {
            void Nic();
            void PrzyjmijObiekt(Typ x);
            Typ ZwróćObiekt();
            Typ PrzyjmijIZwróćObiekt(Typ x);
        }

        class TypInwariantny<T> : ITypInwariantny<T>
        {
            public void Nic()
            {                
            }

            public void PrzyjmijObiekt(T x)
            {
                WriteLine(x.ToString());
            }

            public T ZwróćObiekt()
            {
                return default(T);
            }

            public T PrzyjmijIZwróćObiekt(T x)
            {
                WriteLine(x.ToString());
                return x;
            }
        }
        #endregion

        #region Kontrawariantny
        interface ITypKontrawariantny<in Typ>
        {
            void Nic();
            void PrzyjmijObiekt(Typ x);
            //Typ ZwróćObiekt();
            //Typ PrzyjmijIZwróćObiekt(Typ x);
        }

        class TypKontrawariantny<T> : ITypKontrawariantny<T>
        {
            public void Nic()
            {
            }

            public void PrzyjmijObiekt(T x)
            {
                WriteLine(x.ToString());
            }
        }
        #endregion

        #region Kowariantny
        interface ITypKowariantny<out Typ>
        {
            void Nic();            
            Typ ZwróćObiekt();            
        }

        class TypKowariantny<T> : ITypKowariantny<T>
        {
            public void Nic()
            {
            }

            public T ZwróćObiekt()
            {
                return default(T);
            }
        }
        #endregion

        static void Main(string[] args)
        {
            //inwariantny
            ITypInwariantny<object> o11 = new TypInwariantny<object>();
            TypInwariantny<object> o12 = new TypInwariantny<object>();

            ITypInwariantny<string> o13 = new TypInwariantny<string>();
            TypInwariantny<string> o14 = new TypInwariantny<string>();

            //ITypInwariantny<object> o15 = new TypInwariantny<string>();
            //TypInwariantny<object> o16 = new TypInwariantny<string>();

            //ITypInwariantny<string> o17 = new TypInwariantny<object>();
            //TypInwariantny<string> o18 = new TypInwariantny<object>();

            ITypKontrawariantny<object> o21 = new TypKontrawariantny<object>();
            TypKontrawariantny<object> o22 = new TypKontrawariantny<object>();

            ITypKontrawariantny<string> o23 = new TypKontrawariantny<string>();
            TypKontrawariantny<string> o24 = new TypKontrawariantny<string>();

            //ITypKontrawariantny<object> o25 = new TypKontrawariantny<string>();
            //TypKontrawariantny<object> o26 = new TypKontrawariantny<string>();

            ITypKontrawariantny<string> o27 = new TypKontrawariantny<object>();
            //TypKontrawariantny<string> o28 = new TypKontrawariantny<object>();

            ITypKowariantny<object> o31 = new TypKowariantny<object>();
            TypKowariantny<object> o32 = new TypKowariantny<object>();

            ITypKowariantny<string> o33 = new TypKowariantny<string>();
            TypKowariantny<string> o34 = new TypKowariantny<string>();

            ITypKowariantny<object> o35 = new TypKowariantny<string>();
            //TypKowariantny<object> o36 = new TypKowariantny<string>();

            //ITypKowariantny<string> o37 = new TypKowariantny<object>();
            //TypKowariantny<string> o38 = new TypKowariantny<object>();
        }
    }
}
